(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["devixelHmac"] = factory();
	else
		root["devixelHmac"] = factory();
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const encoder = new TextEncoder();
const isString = (data) => data !== undefined && data !== null && typeof data === "string";
const isObject = (data) => typeof data === "object" &&
    !Array.isArray(data) &&
    data !== null &&
    data !== undefined;
const isArray = (data) => Array.isArray(data);
const ArrayBufferToHex = (data) => {
    return [...new Uint8Array(data)]
        .map((x) => x.toString(16).padStart(2, "0"))
        .join("");
};
const ArrayBufferToBase64 = (data) => {
    return btoa(String.fromCharCode.apply(null, [...new Uint8Array(data)]));
};
const genHMACSecretKey = (HMACSecret, options) => new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
    if (!isString(HMACSecret))
        return reject("HMAC secret must be a string");
    const HMACOptions = {
        name: "HMAC",
        hash: "SHA-256",
    };
    if (isObject(options)) {
        if (options.hash)
            HMACOptions.hash = options.hash;
    }
    try {
        resolve(yield crypto.subtle.importKey("raw", encoder.encode(HMACSecret), HMACOptions, false, ["sign"]));
    }
    catch (exception) {
        reject("Error generating HMAC key");
    }
}));
const genHMACSignature = (payload, secretKey, options) => new Promise((resolve, reject) => __awaiter(void 0, void 0, void 0, function* () {
    if (secretKey === undefined)
        return reject("Invalid secret key please generate using genHMACSecretKey");
    if (!isString(payload) && !isArray(payload))
        return reject("HMAC payload must be a string or an array of string");
    let HMACPayload;
    const signatureOptions = {
        encode: "hex",
        separator: ":",
    };
    if (isObject(options)) {
        if (options.encode)
            signatureOptions.encode = options.encode;
        if (options.separator)
            signatureOptions.separator = options.separator;
    }
    if (isArray(payload)) {
        HMACPayload = encoder.encode(payload.join(signatureOptions.separator));
    }
    if (isString(payload)) {
        HMACPayload = encoder.encode(payload);
    }
    try {
        const HMACSignature = yield crypto.subtle.sign({
            name: "HMAC",
        }, secretKey, HMACPayload);
        if (signatureOptions.encode === "hex")
            resolve(ArrayBufferToHex(HMACSignature));
        else
            resolve(ArrayBufferToBase64(HMACSignature));
    }
    catch (exception) {
        reject("Error generating HMAC signature");
    }
}));
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ({
    genHMACSecretKey,
    genHMACSignature,
});

__webpack_exports__ = __webpack_exports__["default"];
/******/ 	return __webpack_exports__;
/******/ })()
;
});